Download it now!
Bug 123100 - FILEOPEN XLS LibreOffice doesn't indicate the 256 column limitation of the format when editing XLS files
Summary: FILEOPEN XLS LibreOffice doesn't indicate the 256 column limitation of the fo...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
6.3.0.0.alpha0+
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: needsUXEval
Depends on:
Blocks: XLS-Limitations
  Show dependency treegraph
 
Reported: 2019-02-01 10:13 UTC by NISZ LibreOffice Team
Modified: 2020-11-02 21:17 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
An XLS file containing 256 columns of content. (14.50 KB, application/vnd.ms-excel)
2019-02-01 10:13 UTC, NISZ LibreOffice Team
Details
A screenshot showcasing how the same XLS file is displayed in Calc and Excel. (109.23 KB, image/png)
2019-02-01 10:13 UTC, NISZ LibreOffice Team
Details
I just ate your work. Are you okay with that? (52.53 KB, image/png)
2019-02-01 16:05 UTC, Gabor Kelemen
Details
How it looks in LibreOffice 6.3 master (74.77 KB, image/png)
2019-04-16 10:04 UTC, Xisco Faulí
Details

Note You need to log in before you can comment on or make changes to this bug.
Description NISZ LibreOffice Team 2019-02-01 10:13:05 UTC
Description:
The XLS file format has a 256 column limitation, LibreOffice Calc warns the user when saving a file as XLS with more than 256 column of content. However, when an XLS is opened, the user interface shows all 1024 columns as available. It would be better from a user experience standpoint if only 256 columns were shown when an XLS is opened. If the user saves the files as ODS or XLSX, the interface could be updated, and all 1024 available columns could be displayed again. Microsoft Excel already does that, and shows only 256 columns as available when editing an XLS file.

Steps to Reproduce:
    1. Open an XLS file in LibreOffice Calc.
    2. See the number of available columns.

Actual Results:
1024 available columns are shown when editing an XLS file.

Expected Results:
Only 256 available columns should be shown when an XLS is opened.


Reproducible: Always


User Profile Reset: No



Additional Info:
Comment 1 NISZ LibreOffice Team 2019-02-01 10:13:32 UTC
Created attachment 148819 [details]
An XLS file containing 256 columns of content.
Comment 2 NISZ LibreOffice Team 2019-02-01 10:13:48 UTC
Created attachment 148820 [details]
A screenshot showcasing how the same XLS file is displayed in Calc and Excel.
Comment 3 V Stuart Foote 2019-02-01 14:10:35 UTC
We do not "open" XLS sheets--rather we import by filter, and saving back to XLS is an export filter.  Internally we "work" in 1024 columns.

Placing this restriction on format (and for bug 50916 ) we are working of expanding our ODF support beyond 1024 columns. Which would deprecate any work done for this.

IMHO => WF
Comment 4 Gabor Kelemen 2019-02-01 16:00:46 UTC
(In reply to V Stuart Foote from comment #3)
> We do not "open" XLS sheets--rather we import by filter, and saving back to
> XLS is an export filter.  Internally we "work" in 1024 columns.
> 

That's all nice and well, but still: if you open an XLS file, the default save file name, metadata and format will be the same.
 
Which means you can add content in columns 256+, then on save get a humble warning  about additional columns not being saved, and that's it.

If the user doesn't realize that this means data loss and close Calc, then they are out of luck. 
One of ours was not exactly happy about this situation once he got into it.
Comment 5 Gabor Kelemen 2019-02-01 16:05:14 UTC
Created attachment 148849 [details]
I just ate your work. Are you okay with that?

Screenshot of data loss.
Also note that this is displayed only on creating a new XLS file. 
On editing an existing one there is not even this warning displayed.

Can't we really not hide this footgun from our users?
Comment 6 Aron Budea 2019-02-01 16:28:33 UTC
There are plans to handle this with the column limit increase rework, see (among the Tentative decisions):
https://lists.freedesktop.org/archives/libreoffice/2019-January/081909.html

(In reply to Gabor Kelemen from comment #5)
> Also note that this is displayed only on creating a new XLS file. 
> On editing an existing one there is not even this warning displayed.
This is worth opening a separate bug report on, does such a report exist? If not, please create one.
Comment 7 Xisco Faulí 2019-04-16 10:04:16 UTC
Created attachment 150784 [details]
How it looks in LibreOffice 6.3 master
Comment 8 Xisco Faulí 2019-04-16 10:06:39 UTC
this has improved thanks to Noel's work wrt the dynamic column creation magic < https://cgit.freedesktop.org/libreoffice/core/commit/?id=7282014e362a1529a36c88eb308df8ed359c2cfa >
I think we can close this as RESOLVED FIXED.
@Gabor, please create a separate bug for the warning mentioned in comment 5
Comment 9 Gabor Kelemen 2019-04-16 11:54:57 UTC
(In reply to Xisco Faulí from comment #8)
> this has improved thanks to Noel's work wrt the dynamic column creation
> magic <
> https://cgit.freedesktop.org/libreoffice/core/commit/
> ?id=7282014e362a1529a36c88eb308df8ed359c2cfa >

Still there is not a hard limit, only the lack of vertical column separators reminds one that "something is missing" (i.e. columns, not the support to save them). 
I think this is still not a strong enough protection, so we might want to reopen.

> I think we can close this as RESOLVED FIXED.
> @Gabor, please create a separate bug for the warning mentioned in comment 5

Would that be really necessary though?

I mean, imagine this workflow: user opens an existing XLS and we currently allow them to add more than 256 columns of data, which will be lost simply pressing Ctrl-S.

- If we stick to this option, we can warn them that saving in the current format will cause data loss and recommend to choose another format, as Aron proposed.
Then in the file save dialog the user still might or might not do so, and lose their work (or not).

- If we were to introduce a hard limit on the number of columns (as Excel does) there will be no way to add more columns than supported by XLS format and no warning would be necessary.
This would not leave a space to err: if you need more columns, first convert your spreadsheet.

I guess it's time to ask for UX advice on this.
Comment 10 Heiko Tietze 2019-04-17 10:29:40 UTC
First of all, we talk about an outdated alien file format. A completely different solution would be to make it not so easy to save under this format.

I agree with Stuart's c3 (=> WF), and doubt there is any good solution. When you open a file with limitations it could easily result in what you suggest. But the other way around after creating a new file and exporting, it makes not much sense to fiddle around with the UI depending on the chosen file format.

Last but not least the discussion is a bit academic as 256+ columns are not the typical data. Or do you have issues reported by the users?